<?php
/*
 * $Horde: chora/annotate.php,v 1.13 2001/05/13 21:01:57 avsm Exp $
 *
 * Copyright 2000, 2001 Anil Madhavapeddy <anil@recoil.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('CHORA_BASE', dirname(__FILE__));
require_once CHORA_BASE . '/lib/base.php';
require_once HORDE_BASE . '/lib/Horde.php';

if ($conf['compress_pages']) {
    include_once 'HTTP/Compress.php';
    HTTP_Compress::start();
}

/* Spawn the file object */

$fl = new CVSLib_File($CVS, $CVS->cvsRoot().'/'.$where);
checkError($fl->getBrowseInfo());

/* Retrieve the desired revision from the GET variable */

$rev = Horde::getFormData('rev', '1.1');
if (!CVSLib_Rev::valid($rev)) {
    fatal('404 Not Found',"Revision $rev not found");
}

$ann = new CVSLib_Annotate($CVS, $fl);
checkError($lines = $ann->doAnnotate($rev));

$title = "CVS Annotation of $where for version $rev";
include $conf['paths']['templates'] . '/common-header.inc';
include $conf['paths']['templates'] . '/annotate/header.inc';

foreach ($lines as $line) {
    $author = showAuthorName($line['author']);
    $rev = $line['rev'];
    $line = htmlspecialchars($line['line']);
    include($conf['paths']['templates'].'/annotate/line.inc');
}

include $conf['paths']['templates'] . '/annotate/footer.inc';
include $conf['paths']['templates'] . '/common-footer.inc';

if ($conf['compress_pages']) {
    HTTP_Compress::output();
}

?>
