<?
/*
 * $Horde: chora/co.php,v 1.2 2001/06/08 21:03:29 avsm Exp $
 *
 * Copyright 2000, 2001 Anil Madhavapeddy <anil@recoil.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('CHORA_BASE', dirname(__FILE__));
require_once CHORA_BASE . '/lib/base.php';
require_once HORDE_BASE . '/config/mime_mapping.php';
require_once HORDE_BASE . '/config/mime_drivers.php';
require_once HORDE_BASE . '/lib/Horde.php';
require_once HORDE_BASE . '/lib/MIME/Part.php';
require_once HORDE_BASE . '/lib/MIME/Magic.php';
require_once HORDE_BASE . '/lib/MIME/Viewer.php';

if ($conf['compress_pages']) {
    include_once 'HTTP/Compress.php';
    HTTP_Compress::start();
}

$r = Horde::getFormData('r', 0);

/* Should we pretty-print this output or not? */

$plain = Horde::getFormData('p', 0);

/* Check to see if the file exists */

if (!@is_file("$fullname,v")) {
    fatal('404 Not Found', 'File Not Found: ' . str_replace($cvsroot, '', $fullname));
}

/* Is this a valid revision being requested? */

if (!CVSLib_rev::valid($r)) {
    fatal('404 Not Found', "Revision Not Found: $r is not a valid RCS revision number");
}

/* Retrieve the actual checkout */

$checkOut = CVSLib_Checkout::get($CVS, $fullname, $r);

/* Calculate the file extension, to identify the MIME type */

$extension = CVSLib_File::getExtension($fullname);

/* Check error status, and either show error page, or the checkout contents */

if (is_object($checkOut) && $checkOut->id() == CVSLIB_ERROR) {
    checkError($checkOut);

} else if (!$plain) {

    /* Pretty-print the checked out copy */

    $pretty = CVSLib_Checkout::pretty($CVS, $extension, $checkOut);
    if ($pretty->getType() == 'text/html' || $pretty->getType() == 'text/plain') {
        $title = "CVS Checkout of ". basename($fullname). " (revision $r)";
        include $conf['paths']['templates'] . '/common-header.inc';
        include $conf['paths']['templates'] . '/checkout/header.inc';
        if ($pretty->getType() == 'text/plain') {
            echo '<pre>' . htmlspecialchars($pretty->render()) . '</pre>';
        } else {
            echo $pretty->render();
        }
        include $conf['paths']['templates'] . '/checkout/footer.inc';
        include $conf['paths']['templates'] . '/common-footer.inc';
    } else {
        Header('Content-Type: ' . $pretty->getType());
        print $pretty->render();
    }
} else {

    /* Just dump the checked out copy to the user as-is */
    $mime_type = MIME_Magic::extToMIME($extension);
    Header("Content-Type: $mime_type");
    Header("Cache-Control: max-age=2419200");
    fpassthru(CVSLib_Checkout::get($CVS, $fullname, $r));
}
    

if ($conf['compress_pages']) {
    HTTP_Compress::output();
}

?>
